## isospec 1.9.1

=== IsoSpec++/CMakeLists.txt ===
project("IsoSpec")
cmake_minimum_required(VERSION 2.6)

set(my_sources
cwrapper.cpp
allocator.cpp  
dirtyAllocator.cpp 
isoSpec++.cpp 
isoMath.cpp 
marginalTrek++.cpp 
operators.cpp
element_tables.cpp
misc.cpp
)

## platform dependent compiler flags:
include(CheckCXXCompilerFlag)
if (NOT WIN32) # we only want fPIC on non-windows systems (fPIC is implicitly true there)
  CHECK_CXX_COMPILER_FLAG("-fPIC" WITH_FPIC)
  if (WITH_FPIC)
    add_definitions(-fPIC)
  endif()

  # Only add those definitions on non-windows systems
  add_definitions(-std=c++11 -Wall -pedantic -Wextra)
else()
  ## On MSVS we need this for mmap
  set(my_sources ${my_sources} mman.c)
  add_definitions(-DMMAN_LIBRARY)
endif()

add_library(IsoSpec SHARED ${my_sources})

configure_file(IsoSpecConfig.cmake.in "${PROJECT_BINARY_DIR}/IsoSpecConfig.cmake" @ONLY)

export(TARGETS IsoSpec FILE IsoSpecLibrary.cmake)

=== IsoSpec++/Makefile ===
OPTFLAGS=-O3 -march=native -mtune=native
DEBUGFLAGS=-O0 -g -Werror
CXXFLAGS=-std=c++11 -Wall -pedantic -Wextra
SRCFILES=cwrapper.cpp allocator.cpp  dirtyAllocator.cpp  isoSpec++.cpp  isoMath.cpp  marginalTrek++.cpp  operators.cpp element_tables.cpp misc.cpp mman.c

all: unitylib

unitylib:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) unity-build.cpp -fPIC -shared -o libIsoSpec++.so

debug:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

debug-gcc:
	g++ $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

nonunity:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) -DDEBUG -fPIC -shared -o libIsoSpec++.so

clean:
	rm -f libIsoSpec++.so

windows:
	g++ -O3 -std=gnu++11 -O3 -shared -static -static-libstdc++ -static-libgcc unity-build.cpp -o ../IsoSpecPy/IsoSpec++.dll
	x86_64-w64-mingw32-g++.exe -std=gnu++11 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++1.9.1-x64.dll
	i686-w64-mingw32-g++.exe -std=gnu++11 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++1.9.1-x32.dll

=== IsoSpecPy/Makefile ===
reinstall:
	rm -rf IsoSpecPy.egg-info build dist
	pip uninstall -y IsoSpecPy
	python setup.py install

=== IsoSpecR/DESCRIPTION ===
Encoding: UTF-8
Package: IsoSpecR
Type: Package
Title: The IsoSpec Algorithm
Version: 1.9.1
Date: 2018-11-14
Author: Mateusz Krzysztof Lacki and Michal Startek
Maintainer: Matteo Lacki <matteo.lacki@gmail.com>
Description: IsoSpec is a fine structure calculator used for obtaining the most
    probable masses of a chemical compound given the frequencies of the composing
    isotopes and their masses. It finds the smallest set of isotopologues with
    a given probability. The probability is assumed to be that of the product of
    multinomial distributions, each corresponding to one particular element and
    parametrized by the frequencies of finding these elements in nature. These
    numbers are supplied by IUPAC - the International Union of Pure and Applied
    Chemistry.
License: BSD_2_clause + file LICENCE
URL: http://matteolacki.github.io/IsoSpec/
Depends:
    R (>= 3.0.0)
Imports:
    Rcpp (>= 0.12.0)
LazyData: no
LinkingTo: Rcpp
NeedsCompilation: yes
SystemRequirements: C++11
RoxygenNote: 5.0.1

=== tests/C++/Makefile ===
CXX=clang++
OPTFLAGS=-O3 -march=native -mtune=native
DEBUGFLAGS=-O0 -g
TESTFLAGS=-fsanitize=leak,undefined
TESTMEMFLAGS= $(TESTFLAGS) -fsanitize=memory
TESTADDRFLAGS= $(TESTFLAGS) -fsanitize=address
LLVMTESTFLAGS= -fsanitize=dataflow,cfi,safe-stack
CXXFLAGS=-std=c++11 -Wall -I../../IsoSpec++ -Wextra -pedantic
SRCFILES=../../IsoSpec++/unity-build.cpp

all: main_test cmdlines

main_test:
	clang++ $(CXXFLAGS) $(OPTFLAGS) main_test.cpp -o main_test_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) main_test.cpp -o main_test_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -o main_test_dbg
	g++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -DISOSPEC_SKIP_SLOW_TESTS -o main_test_dbg_fast
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -DISOSPEC_SKIP_SLOW_TESTS -fsanitize=address,undefined -o main_test_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -fsanitize=cfi -flto -fvisibility=hidden -o main_test_cfi
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -fsanitize=safe-stack -o main_test_ss
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o main_test_memsan

cmdlines: formula_layered formula_ordered formula_threshold formula_threshold_simple

formula_ordered:
	clang++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_ordered.cpp -o ./from_formula_ordered_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_ordered.cpp -o ./from_formula_ordered_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_ordered.cpp -o ./from_formula_ordered_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_ordered.cpp -fsanitize=address,undefined -o ./from_formula_ordered_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_ordered.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_ordered_memsan

formula_threshold_simple:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -o ./from_formula_threshold_simple_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -o ./from_formula_threshold_simple_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -o ./from_formula_threshold_simple_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -fsanitize=address,undefined -o ./from_formula_threshold_simple_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_threshold_simple_memsan

formula_threshold:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold.cpp -o ./from_formula_threshold_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold.cpp -o ./from_formula_threshold_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold.cpp -o ./from_formula_threshold_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold.cpp -fsanitize=address,undefined -o ./from_formula_threshold_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_threshold_memsan

formula_layered:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_layered.cpp -o ./from_formula_layered_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_layered.cpp -o ./from_formula_layered_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered.cpp -o ./from_formula_layered_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered.cpp -fsanitize=address,undefined -o ./from_formula_layered_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_layered_memsan

ti:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) ../../IsoSpec++/unity-build.cpp titin-test.cpp -o ./titin

mr:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) marginal-test.cpp -o marginal -g

tabulator:
	clang++ -std=c++11 tabulator_test.cpp -o tabulator

la:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) ../../IsoSpec++/unity-build.cpp layered-test.cpp -o layered

IsoThresholdGenerator:
	clang++ -std=c++11 IsoThresholdGenerator.cpp -o IsoThresholdGenerator -lpthread

nr_conf:
	clang++ -std=c++11 nr_conf.cpp -o nr_conf -lpthread

clean:
	rm -f *_gcc *_clang *_dbg *_memsan *_asan IsoThresholdGenerator layered main_test_cfi main_test_ss marginal nr_conf tabulator titin

=== tests/C/Makefile ===
all: test_IsoThresholdGenerator test_IsoOrderedGenerator

test_IsoThresholdGenerator:
	clang++ -std=c++11 -x c++ test_IsoThresholdGenerator.c -o isoThreshold -lpthread

test_IsoOrderedGenerator:
	clang++ -std=c++11 -x c++ test_IsoOrderedGenerator.c -o isoOrdered -lpthread

=== debian/changelog ===
isospec (1.9.1-5ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:05:12 +0100

isospec (1.9.1-5ubuntu1) focal; urgency=medium

  * Remove dependencies on python-dev, python-setuptools, afaict these were
    never needed but now they cause failure to build.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 27 Jan 2020 13:07:12 +1300

isospec (1.9.1-5build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:32:21 +0000

isospec (1.9.1-5) unstable; urgency=low

  * patch: Fix the IsoSpec++ build command line flags for riscv64 as it did not
    recognize the -march flag. I removed it, like I did before for m68k, for
    example.

  * patch: Remove the -march=native compile flag for IsoSpec++ as it is
    considered erroneous to use if cross-builds are performed (Debian QA
    error: E march-native).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Mar 2019 17:23:44 +0100

isospec (1.9.1-4) unstable; urgency=low

  * Remove -mtune -march build flags for the build of the C++ extension of the
    Python module.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Mar 2019 14:56:10 +0100

isospec (1.9.1-3) unstable; urgency=low

  * Add ifeq statements in IsoSpec++/Makefile's patch to fix many 
    arch-specific problems with -march -mtune flags to the compiler 
    command line.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Mar 2019 11:41:44 +0100

isospec (1.9.1-2) unstable; urgency=low

  * Fix Vcs URLs.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 Feb 2019 10:07:16 +0100

isospec (1.9.1-1) unstable; urgency=medium

  * Initial release (Closes: #916218).

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 19 Jan 2019 13:56:13 +0100

=== debian/control ===
Source: isospec
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper (>= 11~),
               dh-python,
               dh-r,
               r-base-dev,
               r-cran-rcpp,
							 python3-dev,
               python3-setuptools,
               python3-cffi,
               doxygen,
               libjs-mathjax
Standards-Version: 4.3.0
Homepage: https://github.com/MatteoLacki/IsoSpec
Vcs-Browser: https://salsa.debian.org/debichem-team/isospec
Vcs-Git: https://salsa.debian.org/debichem-team/isospec.git

Package: libisospec++-dev
Section: libdevel
Architecture: any
Depends: libisospec++1 (= ${binary:Version}),
         ${misc:Depends}
Description: Isotopic fine structure calculator (C++ development files)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the development files.


Package: libisospec++1
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Isotopic fine structure calculator (C++ runtime)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the runtime shared library.


Package: libisospec++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Isotopic fine structure calculator (C++ API documentation)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the developer documentation files.


Package: r-cran-isospec
Section: gnu-r
Architecture: any 
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${R:Depends} 
Recommends: ${R:Recommends} 
Suggests: ${R:Suggests}
Description: Isotopic fine structure calculator for GNU R
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the GNU R library.


Package: python3-isospec
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends}
Recommends: python3-scipy
Description: Isotopic fine structure calculator for Python 3
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package provides the package's Python 3 interface.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export PYBUILD_NAME=isospec

# Taken from CDBS file for R.
rversion	:= $(shell dpkg-query -W -f='$${Version}' r-base-dev)
rapiversion	:= $(shell dpkg-query -W -f='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')

%:
	dh $@ --with python3 --buildsystem=pybuild --sourcedirectory=IsoSpecPy

# Handle the C++ library apart
override_dh_auto_build:
	cd IsoSpec++ && make
# Upstream has not include a Doxygen config file. Add it ourselves
# Note that as 20190205, the doxyfile has been dumbed down to only produce HTML
# doc. Check the 20190205 string for the commented lines.
	cp debian/doxyfile man
# Generate the dev-doc in the man/hml and man/latex directories
	doxygen man/doxyfile
# Remove Doxygen-generated file that has no use.
	#rm man/man/man3/_home_rusconi_*

# sed-based replacement of the cloudflare URL with the MathJax.js file from the
# libjs-mathjax package
	sh debian/replace-mathjax-cloudflare-url-local-file.sh

# Actually craft the refman.pdf file.
#
# No, at the moment no, there is a bug in the Doxygen-generated LaTeX code
# and I do not know how to fix it. HTML documentation is largely enough.
#	cd man/latex && make

override_dh_auto_install:
	dh_auto_install -O--buildsystem=R --sourcedirectory=IsoSpecR
# Remove the license file.
	rm debian/tmp/usr/lib/R/site-library/IsoSpecR/LICENCE
	mv debian/tmp tmp-install
	dh_auto_install

## isospec 2.1.3

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration

cmake_minimum_required(VERSION 3.12)

# CMake script for the IsoSpec library
# Author: Anonymous and Filippo Rusconi
# This script was present in the source tree but was
# highly rudimentary. I have implemented most of what is
# here (Filippo Rusconi).
# Last Modifs: July 2020

############################################################
############################################################
# Basic information about project

project(IsoSpec
    DESCRIPTION "A program to calculate isotopic clusters"
    HOMEPAGE_URL "https://github.com/MatteoLacki/IsoSpec")

set(ISOSPEC_VERSION_MAJOR "2")
set(ISOSPEC_VERSION_MINOR "1")
set(ISOSPEC_VERSION_PATCH "3")
set(ISOSPEC_LIB_NAME "libIsoSpec++")
set(ISOSPEC_VERSION "${ISOSPEC_VERSION_MAJOR}.${ISOSPEC_VERSION_MINOR}.${ISOSPEC_VERSION_PATCH}")
set(VERSION 2.1.3)
set(ISOSPEC_LIB_VERSION ${ISOSPEC_VERSION})
set(ISOSPEC_LIB_SOVERSION ${ISOSPEC_VERSION_MAJOR})

# Command to enable debug mode
# cmake -DCMAKE_BUILD_TYPE=Debug 


# This setting is also typically overridden by 
# configuring the build system like this:
# cmake -DCMAKE_INSTALL_PREFIX=/usr
# It needs to be set before include(GNUInstallDirs)
# below, because it roots all the other dirs' configs.

if(NOT CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

# This module sets a number of installation directories 
# according to the GNU coding standards. It takes the
# CMAKE_INSTALL_PREFIX and then add the directories to it.
include(GNUInstallDirs)

# Add folder where are supportive functions
# that contain toolchains: for UNIX/WIN/MAC
# that contain modules useful on any system.
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
#message("CMAKE_MODULE_PATH:" ${CMAKE_MODULE_PATH})

# This says that when compiling, .h files must also be
# searche in the current directory where cpp files are 
# compiled.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("")
message("\n${BoldRed}Configuring build for project ${PROJECT_NAME}${ColourReset}\n")
message("")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
    execute_process( COMMAND cmake -E copy_if_different
        ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
        ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
        )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "${BoldGreen}Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)
message(STATUS "${BoldGreen}Setting definition -pedantic.${ColourReset}")
add_definitions(-pedantic)

if(WARN_AS_ERROR)
    message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
    add_definitions(-Werror)
endif()

message(STATUS "${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")
message(STATUS "${BoldGreen}CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration

# MXE is a pretty cool cross-compilation environment that allows one
# to build Win software right into GNU/Linux.
if(MXE)

    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
    #include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

elseif(UNIX AND NOT APPLE)

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(WIN32 OR _WIN32)

    if(WIN10MINGW64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
    endif()

elseif(APPLE)

    include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message("${BoldRed}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    #message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    #message(STATUS "Compiling in debug mode.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    #message(STATUS "Compiling in release with debug info mode.")
endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}.${ColourReset}")


# message(STATUS CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH})

# Now actually deal with the C++ source code.
add_subdirectory(IsoSpec++)

=== Examples/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the example material for ${PROJECT_NAME} ${ColourReset}")
message("")


###############
# install stuff

install(DIRECTORY C++  Python  R
	DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/isospec/examples)

message("")
message(STATUS "${BoldGreen}Finished configuration for the example material.${ColourReset}")
message("")

=== IsoSpec++/Makefile ===
OPTFLAGS=-O3 -march=native -mtune=native
DEBUGFLAGS=-O0 -g -Werror -DISOSPEC_DEBUG -DDEBUG -D_GLIBCXX_DEBUG
CXXFLAGS=-std=c++17 -Wall -pedantic -Wextra -Wshadow -Wcast-align -Wcast-qual -Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self -Wmissing-include-dirs -Wno-old-style-cast -Woverloaded-virtual -Wredundant-decls -Wshadow -Wno-sign-conversion -Wsign-promo -Wswitch-default -Wundef -Werror
SRCFILES=cwrapper.cpp allocator.cpp  dirtyAllocator.cpp  isoSpec++.cpp  isoMath.cpp  marginalTrek++.cpp  operators.cpp element_tables.cpp misc.cpp mman.cpp fixedEnvelopes.cpp fasta.cpp

all: unitylib

unitylib:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) unity-build.cpp -fPIC -shared -o libIsoSpec++.so

debug:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

debug-gcc:
	g++ $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

nonunity:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) -DDEBUG -fPIC -shared -o libIsoSpec++.so

clean:
	rm -f libIsoSpec++.so

windows:
	#g++ -O3 -std=gnu++1z -O3 -shared -static -static-libstdc++ -static-libgcc unity-build.cpp -o ../IsoSpecPy/IsoSpec++.dll
	x86_64-w64-mingw32-g++.exe -std=c++17 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++-2.1.0-x64.dll
	i686-w64-mingw32-g++.exe -std=c++17 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++-2.1.0-x32.dll
check:
	cpplint *.cpp *.h
	#cppcheck --std=c++17 --language=c++ --enable=style,portability,missingInclude,performance -q --force *.cpp *.h --suppress=memleakOnRealloc:*:* --inline-suppr --template={file}:{line}\ \({severity}\)\ \<{id}\>:\ {message}

check11:
	$(CXX) -std=c++11 -Wall -pedantic -Wextra -Wshadow -fsyntax-only unity-build.cpp

asm:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) unity-build.cpp -S -o out.S

=== IsoSpecR/DESCRIPTION ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Package: IsoSpecR
 Type: Package
 Title: The IsoSpec Algorithm
-Version: 1.9.1
-Date: 2018-11-14
+Version: 2.1.3
+Date: 2020-10-29
 Author: Mateusz Krzysztof Lacki and Michal Startek
 Maintainer: Matteo Lacki <matteo.lacki@gmail.com>
 Description: IsoSpec is a fine structure calculator used for obtaining the most
@@ -13,15 +13,19 @@
     multinomial distributions, each corresponding to one particular element and
     parametrized by the frequencies of finding these elements in nature. These
     numbers are supplied by IUPAC - the International Union of Pure and Applied
-    Chemistry.
+    Chemistry. See: Lacki, Valkenborg, Startek (2020) <DOI:10.1021/acs.analchem.0c00959>
+    and Lacki, Startek, Valkenborg, Gambin (2017) <DOI:10.1021/acs.analchem.6b01459>
+    for the description of the algorithms used.
 License: BSD_2_clause + file LICENCE
 URL: http://matteolacki.github.io/IsoSpec/
 Depends:
     R (>= 3.0.0)
 Imports:
     Rcpp (>= 0.12.0)
+Suggests:
+    testthat
 LazyData: no
 LinkingTo: Rcpp
 NeedsCompilation: yes
-SystemRequirements: C++11
-RoxygenNote: 5.0.1
+SystemRequirements: C++14
+RoxygenNote: 6.1.1

=== debian/changelog ===
isospec (2.1.3-1) unstable; urgency=low

  * New upstream 2.1.3 release.

  * d/copyright: remove stanza on exclusion of files because these are now
    removed from upstream following my own recommendation, yay! Also, no more
    dfsg suffix to the package name.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 15 Oct 2020 16:04:44 +0200

isospec (2.1.2+dfsg1-3) unstable; urgency=low

  * Remove the r-cran-isospec package as it is alreay packaged by Dylan Aîssi
    <daissi@debian.org>. 
    See https://salsa.debian.org/r-pkg-team/r-cran-isospecr.

  * Closes: #962130 by Dylan Aîssi although we'll need to sort out
    how to provide the R package basing it on the R-cran repository 
    IsoSpecR package (see mail in the bug). Dylan, if you are listening,
    maybe you could open an ITP bug?

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 24 Aug 2020 12:59:00 +0200

isospec (2.1.2+dfsg1-2) unstable; urgency=low

  * Remove unversioned Python (Closes: #967147), thanks to 
    Matthias Klose <doko@debian.org> for the report. Nothing more to do than
    remove the python* build-depends packages.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 04 Aug 2020 18:10:59 +0200

isospec (2.1.2+dfsg1-1) unstable; urgency=low

  * Upstream 2.1.2 release (git commit :
    622281caab9d78a75379f56295204bd40a77e6f0;

  * New packaging with all the Filippo Rusconi's CMake-based build system
    integrated upstream and some last-moment patches.

  * Many other modifications to improve the quality of the package.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 20 Jul 2020 18:23:29 +0200

isospec (2.1.0+dfsg1-1) UNRELEASED; urgency=low

  * New upstream version.

  * Patches to implement more complete CMake-based build system,
    that upstream intends to adopt.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 08 Jun 2020 16:43:14 +0200

isospec (2.0.2+dfsg1-4) UNRELEASED; urgency=low

  * Multi-arch installment.

  *  /*attention check source-only-upload with
     dpkg-buildpackage --changes-option=-S */

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 08 Jun 2020 11:42:02 +0200

isospec (2.0.2+dfsg1-3) unstable; urgency=low

  *  Since July 2019, binaries uploaded by maintainers are not allowed to
     migrate to testing. In other words, packages must have source-only uploads
     before they can reach the next release
     (Thanks to Boyuan Yang <byang@debian.org> ; Closes: #961023).

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 19 May 2020 16:10:00 +0200

isospec (2.0.2+dfsg1-2) unstable; urgency=low

  * Reinstate the -mtune -march build flags path for the
    build  of the C++ extension of the Python module. (Closes: #960340).
    Thanks to Sebastian Ramacher <sramacher@debian.org> for the bug report.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 13 May 2020 14:40:03 +0200

isospec (2.0.2+dfsg1-1) unstable; urgency=low

  * New upstream version including the CMakeLists.txt file that
    upstream accecpted from me (and also modified later).

  * Standards-Version: 4.5.0 (no changes needed).

  * Add d/watch.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 07 May 2020 11:07:23 +0200

=== debian/control ===
Source: isospec
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-exec (>= 0.3),
 dpkg-dev (>= 1.18.25),
 graphicsmagick-imagemagick-compat,
 cmake (>=3.12),
 d-shlibs (>= 0.48~),
 dh-python,
 python3-dev,
 python3-setuptools,
 python3-cffi,
 texlive-latex-base,
 texlive-latex-recommended,
 texlive-latex-extra,
 texlive-plain-generic,
 texlive-fonts-recommended,
 texlive-font-utils,
 ghostscript,
 doxygen,
 libjs-mathjax
Standards-Version: 4.5.0
Homepage: https://github.com/MatteoLacki/IsoSpec
Vcs-Browser: https://salsa.debian.org/debichem-team/isospec
Vcs-Git: https://salsa.debian.org/debichem-team/isospec.git

Package: libisospec++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libisospec++2 (= ${binary:Version}),
         ${misc:Depends}
Recommends: libisospec++-doc
Description: Isotopic fine structure calculator (C++ development files)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the development files.


Package: libisospec++2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Replaces: libisospec++1
Breaks: libisospec++1
Suggests: libisospec++-doc
Description: Isotopic fine structure calculator (C++ runtime)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the runtime shared library.


Package: python3-isospec
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends}
Recommends: python3-scipy, libisospec++-doc
Description: Isotopic fine structure calculator for Python 3
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package provides the package's Python 3 interface.


Package: libisospec++-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Isotopic fine structure calculator (C++ API documentation)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .

## isospec 2.2.1

=== IsoSpec++/CMakeLists.txt ===
# CMake script for IsoSpec++ library
# Author: Filippo Rusconi
# Created: June 2020

message(\n${BoldRed}"Now configuring IsoSpec++/ for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)


set(isospec_SRCS
	unity-build.cpp
	)


# Not sure I understand this. Is this the way to test for MSVS in CMake land ?
if(WIN32 OR _WIN32)

	if(MSVC)
		set(my_sources ${my_sources})
		add_definitions(-DMMAN_LIBRARY)
	endif()

endif()


#message(STATUS "ISOSPEC_LIB_VERSION: ${ISOSPEC_LIB_VERSION}")
#message(STATUS "ISOSPEC_LIB_SOVERSION: ${ISOSPEC_LIB_SOVERSION}")


######### The shared library #########

add_library(IsoSpec++-shared SHARED ${isospec_SRCS})

set_target_properties(IsoSpec++-shared
	PROPERTIES OUTPUT_NAME IsoSpec++
	CLEAN_DIRECT_OUTPUT 1
	VERSION ${ISOSPEC_LIB_VERSION}
	SOVERSION ${ISOSPEC_LIB_SOVERSION}
	)


######### The static library #########

add_library(IsoSpec++-static STATIC ${isospec_SRCS})

set_target_properties(IsoSpec++-static
	PROPERTIES OUTPUT_NAME IsoSpec++
	CLEAN_DIRECT_OUTPUT 1
	)


# Install both shared and static libs

install(TARGETS IsoSpec++-shared IsoSpec++-static
	LIBRARY NAMELINK_SKIP 
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
	# This one is for WIN32
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	)


# Do not know how this would still be useful.
# export(TARGETS IsoSpec++ FILE IsoSpecLibrary.cmake)

=== IsoSpec++/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 OPTFLAGS=-O3 -march=native -mtune=native
 DEBUGFLAGS=-O0 -g -Werror -DISOSPEC_DEBUG -DDEBUG -D_GLIBCXX_DEBUG
-CXXFLAGS=-std=c++17 -Wall -pedantic -Wextra -Wshadow -Wcast-align -Wcast-qual -Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self -Wmissing-include-dirs -Wno-old-style-cast -Woverloaded-virtual -Wredundant-decls -Wshadow -Wno-sign-conversion -Wsign-promo -Wswitch-default -Wundef -Werror
+CXXFLAGS=-std=c++17 -Wall -pedantic -Wextra -Wshadow -Wcast-align -Wcast-qual -Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self -Wmissing-include-dirs -Wno-old-style-cast -Woverloaded-virtual -Wredundant-decls -Wshadow -Wno-sign-conversion -Wsign-promo -Wswitch-default -Wundef
 SRCFILES=cwrapper.cpp allocator.cpp  dirtyAllocator.cpp  isoSpec++.cpp  isoMath.cpp  marginalTrek++.cpp  operators.cpp element_tables.cpp misc.cpp mman.cpp fixedEnvelopes.cpp fasta.cpp
 
 all: unitylib

=== IsoSpecR/DESCRIPTION ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Package: IsoSpecR
 Type: Package
 Title: The IsoSpec Algorithm
-Version: 2.1.3
-Date: 2020-10-29
+Version: 2.2.0
+Date: 2021-07-01
 Author: Mateusz Krzysztof Lacki and Michal Startek
 Maintainer: Matteo Lacki <matteo.lacki@gmail.com>
 Description: IsoSpec is a fine structure calculator used for obtaining the most
@@ -28,4 +28,4 @@
 LinkingTo: Rcpp
 NeedsCompilation: yes
 SystemRequirements: C++14
-RoxygenNote: 6.1.1
+RoxygenNote: 7.1.1

=== tests/C/Makefile ===
all: test_IsoThresholdGenerator test_IsoOrderedGenerator

test_IsoThresholdGenerator:
	clang++ -std=c++17 -x c++ test_IsoThresholdGenerator.c -o isoThreshold -lpthread

test_IsoOrderedGenerator:
	clang++ -std=c++17 -x c++ test_IsoOrderedGenerator.c -o isoOrdered -lpthread
clean:
	rm -f isoOrdered isoThreshold

=== debian/changelog ===
isospec (2.2.1-4.1build2) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 11:54:37 +0100

isospec (2.2.1-4.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 01:25:59 +0000

isospec (2.2.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062459

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 11:50:05 +0000

isospec (2.2.1-4) unstable; urgency=low

  * Fixes as suggested by Janitor. See below.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 25 Aug 2023 12:18:04 +0200

isospec (2.2.1-3) unstable; urgency=low

  * Fix the Bug#1047034: isospec: Fails to build source after successful build
    by improving the override_dh_clean target in d/rules. Thanks to Lucas
    Nussbaum <lucas@debian.org> for reporting. Closes: #1047034.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 25 Aug 2023 11:42:48 +0200

isospec (2.2.1-2) UNRELEASED; urgency=medium

  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on cmake, d-shlibs, dh-exec and
      dpkg-dev.

 -- Debian Janitor <janitor@jelmer.uk>  Mon, 31 Oct 2022 15:36:43 -0000

isospec (2.2.1-1) unstable; urgency=low

  * New upstream version.
  
  * Updates to patches.

  * Standards-Version: 4.6.1 (routine update).

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 12 Nov 2022 22:05:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: isospec
 Section: science
 Priority: optional
-Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
 Uploaders: Filippo Rusconi <lopippo@debian.org>
-Build-Depends: debhelper-compat (= 13),
- dh-exec (>= 0.3),
- dpkg-dev (>= 1.18.25),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
+ dh-exec,
  graphicsmagick-imagemagick-compat,
- cmake (>=3.12),
- d-shlibs (>= 0.48~),
+ cmake,
+ d-shlibs,
  dh-python,
  python3-dev,
  python3-setuptools,
@@ -22,7 +22,7 @@
  ghostscript,
  doxygen,
  libjs-mathjax
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/MatteoLacki/IsoSpec
 Vcs-Browser: https://salsa.debian.org/debichem-team/isospec
 Vcs-Git: https://salsa.debian.org/debichem-team/isospec.git
@@ -31,7 +31,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libisospec++2 (= ${binary:Version}),
+Depends: libisospec++2t64 (= ${binary:Version}),
          ${misc:Depends}
 Recommends: libisospec++-doc
 Description: Isotopic fine structure calculator (C++ development files)
@@ -42,14 +42,15 @@
  This package ships the development files.
 
 
-Package: libisospec++2
+Package: libisospec++2t64
+Provides: ${t64:Provides}
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends},
          ${misc:Depends}
-Replaces: libisospec++1
-Breaks: libisospec++1
+Replaces: libisospec++2, libisospec++1
+Breaks: libisospec++2 (<< ${source:Version}), libisospec++1
 Suggests: libisospec++-doc
 Description: Isotopic fine structure calculator (C++ runtime)
  IsoSpec implements an algorithm for fast computation of isotopologues of

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export LC_ALL=C.UTF-8

# For automating the d/*.links stuff.
export ISOSPEC_LIB_VERSION=2.2.1
export ISOSPEC_LIB_SOVERSION=2

export PYBUILD_NAME=isospec

export PYBUILD_SYSTEM=distutils

# Taken from CDBS file for R.
rversion	:= $(shell dpkg-query -W -f='$${Version}' r-base-dev)
rapiversion	:= $(shell dpkg-query -W -f='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')

%:
	dh $@ --with python3

override_dh_clean:
	rm -rf obj-x86_64-linux-gnu
	rm -rf build
	rm -f compile_commands.json
	rm -rf .pc
	rm -rf IsoSpecPy.egg-info
	
	# The setup.py script immediately creates that link which
	# makes the package building to stop because it finds that 
	# the source tree has changed. So, first remove that link,
	# that we'll recreate when we need it later, in the
	# override_dh_auto_build target.
	
	rm -rf IsoSpecPy/IsoSpec++
	rm -rf .pybuild/
	rm -rf tmp-install/
	rm -rf IsoSpec++/IsoSpec++
	rm -rf IsoSpecPy/build/
	rm -rf man/html/
	rm -rf man/latex/
	rm -rf man/man/
	
	# Now the default target
	dh_clean

configure_python_module:
	dh_auto_configure -O--buildsystem=pybuild -O--system=distutils --sourcedirectory=.

configure_cpp_library:
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DISOSPEC_LIB_VERSION=2.1.0 -DISOSPEC_LIB_SOVERSION=2

configure_cpp_library_doc:
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DISOSPEC_LIB_VERSION=2.1.0 -DISOSPEC_LIB_SOVERSION=2

override_dh_auto_configure: configure_cpp_library configure_cpp_library_doc configure_python_module

build_python_module: configure_python_module
	dh_auto_build -O--buildsystem=cmake -O--system=distutils --sourcedirectory=.

build_cpp_library: configure_cpp_library
	dh_auto_build -O--buildsystem=cmake

build_cpp_library_doc: configure_cpp_library_doc
	# Generate the dev-doc in the man/hml and man/latex directories
	#doxygen man/doxyfile
	dh_auto_build -O--buildsyste=cmake -- html_doc
	dh_auto_build -O--buildsyste=cmake -- pdf_doc
	# sed-based replacement of the cloudflare URL with the MathJax.js file from the
	# libjs-mathjax package
	sh debian/replace-mathjax-cloudflare-url-local-file.sh

override_dh_auto_build: build_python_module build_cpp_library build_cpp_library_doc
	# Recreate the symlink that was created by setup.py 
	# and that we had to remove at the override_dh_clean target.
	ln -sf IsoSpec++ IsoSpecPy/IsoSpec++

override_dh_auto_install: override_dh_auto_build
	# Install the Python module
	dh_auto_install -O--buildsystem=pybuild -O--system=distutils --sourcedirectory=.
	# Install the C++ library
	dh_auto_install -O--buildsystem=cmake
	# Now remove the links, that we'll provide using d/*.links
	# So that we can use libIsoSpec++.so.* in d/*.install
	rm -f debian/tmp/usr/lib/*/libIsoSpec++.so 
	rm -f debian/tmp/usr/lib/*/libIsoSpec++.so.$(ISOSPEC_LIB_SOVERSION)
